/*********************************************************************
 * TCPTvNCAgvO (ZS6180smp.c)
 * Ver 1.0 2004N29
 * [jXvVXe
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define BUFSIZE 8192
#define DEFAULT_PORT 23

enum {CMD_NAME, DST_IP, DST_PORT};

int main(int argc, char *argv[])
{
  struct sockaddr_in server;	/* T[õAhX		*/
  unsigned long dst_ip;		/* T[oIPAhX		*/
  int port;			/* |[gԍ			*/
  int s;			/* \PbgfBXNv^		*/
  int n;			/* ̓f[^̃oCg		*/
  char buf[BUFSIZE];		/* Mobt@			*/
  char cmd[BUFSIZE];		/* Mobt@			*/
  struct timeval tv;		/* select̃^CAEg		*/
  fd_set readfd;		/* selectŌofBXNv^	*/
 
  /* ̃`FbN */
  if (argc != 2 && argc != 3) {
    fprintf(stderr, "Usage: %s hostname [port]\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  /* T[oIPAhX𒲂ׂ */
  if ((dst_ip = inet_addr(argv[DST_IP])) == INADDR_NONE) {
    struct hostent *he;		/* zXg */

    if ((he = gethostbyname(argv[DST_IP])) == NULL) {
      fprintf(stderr, "gethostbyname error\n");
      exit(EXIT_FAILURE);
    }
    memcpy((char *)&dst_ip, (char *)he->h_addr, he->h_length);
  }

  /* T[õ|[gԍ𒲂ׂ */
  if (argc == 3) {
    if ((port = atoi(argv[DST_PORT])) == 0) {
      struct servent *se;	/* T[rX */

      if ((se = getservbyname(argv[DST_PORT], "tcp")) != NULL)
	port = (int)ntohs((u_short)se->s_port);
      else {
	fprintf(stderr, "getservbyname error\n");
	exit(EXIT_FAILURE);
      }
    }
  }
  else
    port = DEFAULT_PORT;

  /* TCPŃ\PbgJ */
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    exit(EXIT_FAILURE);
  }

  /* T[õAhXݒ肵RlNVm */
  memset((char *) &server, 0, sizeof(server));
  server.sin_family      = AF_INET;
  server.sin_addr.s_addr = dst_ip;
  server.sin_port        = htons(port);
  if (connect(s, (struct sockaddr *) &server, sizeof server) < 0) {
    perror("connect");
    exit(EXIT_FAILURE);
  }

  printf("connected to '%s'\n", inet_ntoa(server.sin_addr));

  /* NCAgC[` */
  while (1) {
    /* select̃^CAEg̐ݒ */
    tv.tv_sec = 600;
    tv.tv_usec = 0;
  
    /* ẂAT[õbZ[W邩 */
    FD_ZERO(&readfd);
    FD_SET(0, &readfd);
    FD_SET(s, &readfd);
    if ((select(s+1, &readfd, NULL, NULL, &tv)) <= 0) {
      fprintf(stderr, "\nTimeout\n");
      break;
    }
  
    /* W */
    if (FD_ISSET(0, &readfd)) {
      if ((n = read(0, buf, BUFSIZE-1)) <= 0)
	break;
      buf[n] = '\n';
      sscanf(buf, "%s", cmd);
      if (strcmp(cmd, "quit") == 0)
	break;
      buf[n-1] = 0x0d;
      buf[n] = 0x0a;
      buf[n+1] = '\0';
      if (send(s, buf, n+1, 0) <= 0)
	break;
    }

    /* T[o */
    if (FD_ISSET(s, &readfd)) {
      if ((n = recv(s, buf, BUFSIZE-1, 0)) <= 0) {
	fprintf(stderr, "connection closed.\n");
	exit(EXIT_FAILURE);
      }
      buf[n] = '\0';
      printf("%s", buf);
      fflush(stdout);
    }
  }
  strcpy(buf, "quit");
  send(s, buf, n, 0);
  close(s);

  return EXIT_SUCCESS;
}
